%define name drakxtools
%define version 10.4.81flux
%define sversion 10.4.81
%define release %mkrel 39

Summary: The drakxtools (XFdrake, diskdrake, keyboarddrake, mousedrake...)
Name:    %{name}
Version: %{version}
Release: %{release}
Url:     http://qa.mandriva.com/twiki/bin/view/Main/DrakXTools
Source0: %name-%sversion.tar.bz2

###
#PCLinuxOS Patches
###

#patches to  update drak3d and support compiz-fusion
Patch0:		drak3d.patch
Patch1:		compositing-wm-support-glx.patch

#patch to add gfxboot support and depreciate lilo
Patch2:		bootloader-gfxboot.patch

#TEXSTAR PATCHES
Patch11:	bootloader.pm.patch
Patch12:	bootsplash.pm.patch
Patch13:	messages.pm.patch
Patch14:	standalone.pm.patch
Patch15:	data.pm.patch
Patch16:	printerdrake.pm.patch
Patch17:	do_pkgs.pm.patch
Patch18:	thirdparty.pm.patch
Patch19:	drakfirewall.pm.patch
Patch20:	pxe.pm.patch
Patch21:	drakconnect.patch
Patch22:	drakhelp.patch
Patch23:	draksound.patch
Patch24:	drakxtv.patch
Patch25:	logdrake.patch
Patch26:	net_applet.patch
Patch27:	net_monitor.patch
Patch28:	scannerdrake.patch
Patch29:	printerdrake.patch
Patch30:	harddrake2.patch
Patch31:	mygtk2.pm.patch
Patch32:	cpufreq.patch
Patch33:	bootloader.pm2.patch
Patch35:	glx.patch
Patch36:	drak3d2.patch
Patch38:	drakfont.patch
Patch39:	drak3d3.patch
Patch40:	net_applet2.patch
Patch41:	drakxtools-10.4.81-ldetect0.7.patch
Patch42:	drakxtools-module_hyphen2underscore.patch

License: GPL
Group: System/Configuration/Other
Requires: %{name}-newt = %version-%release, perl-Gtk2, perl-Glib, xtest, font-tools, usermode, perl-MDK-Common, perl-Net-DBus
Requires: foomatic-db-engine
Requires: drakconf-icons
Requires: gtkdialogs
Requires: do-vesa
BuildRequires: gettext, gtk+2-devel, ldetect-devel >= 0.7, ncurses-devel, newt-devel, perl-devel, libext2fs-devel, perl_checker
BuildRequires: libxxf86misc-devel
BuildRoot: %_tmppath/%name-buildroot
Provides: draksec
Obsoletes: draksec
Provides:  drakxtools-newt-10.4.81
Obsoletes: drakxtools-newt-10.4.81
Provides:  drakxtools-backend-10.4.81
Obsoletes: drakxtools-backend-10.4.81
Provides:  drakxtools-http-10.4.81
Obsoletes: drakxtools-http-10.4.81
Provides:  drakxtools-10.4.81
Obsoletes: drakxtools-10.4.81
Provides:  drakx-finish-install-10.4.81
Obsoletes: drakx-finish-install-10.4.81
Provides:  harddrake-10.4.81
Obsoletes: harddrake-10.4.81
Provides:  harddrake-ui-10.4.81
Obsoletes: harddrake-ui-10.4.81
%define _requires_exceptions perl(Net::FTP)\\|perl(Time::localtime)\\|perl(URPM)\\|perl(ctxhelp)\\|perl(steps)

%package newt
Summary: The drakxtools (XFdrake, diskdrake, keyboarddrake, mousedrake...)
Group: System/Configuration/Other
Requires: perl-base, usermode-consoleonly
Requires: perl-Locale-gettext
Requires: module-init-tools
Requires: %{name}-backend = %version-%release
%ifnarch %{sunsparc}
Requires: monitor-edid
%endif %{sunsparc}
Requires: netprofile
Obsoletes: diskdrake kbdconfig mouseconfig printtool setuptool drakfloppy
Provides: diskdrake, kbdconfig mouseconfig printtool setuptool, drakfloppy = %version-%release
Provides: perl(Newt::Newt)
Provides: perl(network::isdn_consts)

%package backend
Summary: Drakxtools libraries and background tools 
Group: System/Configuration/Other
Requires: ldetect-lst
Requires: dmidecode
Requires: perl-File-FnMatch
Requires: perl-suid
Requires: perl-String-ShellQuote


%package http
Summary: The drakxtools via http
Group: System/Configuration/Other
Requires: %{name}-newt = %version-%release, perl(Net::SSLeay) >= 1.22-1, perl-Authen-PAM >= 0.14-1, perl-CGI >= 2.91-1
Requires(pre): rpm-helper
Requires(post): rpm-helper

%package -n drakx-finish-install
Summary: First boot configuration
Group: System/Configuration/Other
Requires: %{name} = %version-%release

%package -n harddrake
Summary: Main Hardware Configuration/Information Tool
Group: System/Configuration/Hardware
Requires: %{name}-newt = %version-%release
Obsoletes: kudzu, kudzu-devel, libdetect0, libdetect0-devel, libdetect-lst, libdetect-lst-devel, detect, detect-lst
Provides: kudzu, kudzu-devel, libdetect0, libdetect0-devel, libdetect-lst, libdetect-lst-devel, detect, detect-lst
Requires(pre): rpm-helper
Requires(post): rpm-helper

%package -n harddrake-ui
Summary: Main Hardware Configuration/Information Tool
Group: System/Configuration/Hardware
Requires: %name = %version-%release
Requires: sane-backends

%description
Contains many PCLinuxOS applications simplifying users and
administrators life on a PCLinuxOS machine. Nearly all of
them work both under XFree (graphical environment) and in console
(text environment), allowing easy distant work.

drakbug: interactive bug report tool

drakbug_report: help find bugs in DrakX

drakclock: date & time configurator

drakfloppy: boot disk creator

drakfont: import fonts in the system

draklog: show extracted information from the system logs

draknet_monitor: connection monitoring

drakperm: msec GUI (permissions configurator)

drakprinter: detect and configure your printer

draksec: security options managment / msec frontend

draksplash: bootsplash themes creation

drakTermServ: terminal server configurator

listsupportedprinters: list printers

net_applet: applet to check network connection

%description backend
See package %name

%description newt
Contains many PCLinuxOS applications simplifying users and
administrators life on a PCLinuxOS machine. Nearly all of
them work both under XFree (graphical environment) and in console
(text environment), allowing easy distant work.

adduserdrake: help you adding a user

diskdrake: DiskDrake makes hard disk partitioning easier. It is
graphical, simple and powerful. Different skill levels are available
(newbie, advanced user, expert). It's written entirely in Perl and
Perl/Gtk. It uses resize_fat which is a perl rewrite of the work of
Andrew Clausen (libresize).

drakauth: configure authentification (LDAP/NIS/...)

drakautoinst: help you configure an automatic installation replay

drakbackup: backup and restore your system

drakboot: configures your boot configuration (Lilo/GRUB,
Bootsplash, X, autologin)

drakconnect: LAN/Internet connection configuration. It handles
ethernet, ISDN, DSL, cable, modem.

drakfirewall: simple firewall configurator

drakgw: internet connection sharing

drakkeyboard: configure your keyboard (both console and X)

draklocale: language configurator, available both for root
(system wide) and users (user only)

drakmouse: autodetect and configure your mouse

drakproxy: proxies configuration

drakscanner: scanner configurator

draksound: sound card configuration

drakvpn: VPN configuration (openvpn, vpnc)

drakx11: menu-driven program which walks you through setting up
your X server; it autodetects both monitor and video card if
possible

drakxservices: SysV services and daemons configurator

drakxtv: auto configure tv card for xawtv grabber

lsnetdrake: display available nfs and smb shares

lspcidrake: display your pci information, *and* the corresponding
kernel module

%description http
This add the capability to be runned behind a web server to the drakx tools.
See package %name


%description -n drakx-finish-install
For OEM-like duplications, it allows at first boot:
- network configuration
- creating users
- setting root password
- choosing authentication


%description -n harddrake
The harddrake service is a hardware probing tool run at system boot
time to determine what hardware has been added or removed from the
system.
It then offer to run needed config tool to update the OS
configuration.


%description -n harddrake-ui
This is the main configuration tool for hardware that calls all the
other configuration tools.
It offers a nice GUI that show the hardware configuration splitted by
hardware classes.


%prep
%setup -q -n %name-%sversion

%patch0 -p1
%patch1 -p1
%patch2 -p1

%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
#%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1 
%patch33 -p1
%patch35 -p1
%patch36 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1

%build
%make CFLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT

%make PREFIX=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/{%_initrddir,%_sysconfdir/{X11/xinit.d,X11/wmsession.d,sysconfig/harddrake2}}
touch $RPM_BUILD_ROOT/etc/sysconfig/harddrake2/previous_hw

dirs1="usr/lib/libDrakX usr/share/libDrakX"
(cd $RPM_BUILD_ROOT ; find $dirs1 usr/bin usr/sbin ! -type d -printf "/%%p\n")|egrep -v 'bin/.*harddrake' > %{name}.list
(cd $RPM_BUILD_ROOT ; find $dirs1 -type d -printf "%%%%dir /%%p\n") >> %{name}.list

perl -ni -e '/dbus_object\.pm|network\/(ifw|monitor)\.pm|Xdrakres|clock|drak(backup|bug|clock|floppy|font|hosts|ids|log|net_monitor|nfs|perm|printer|sec|splash|TermServ)|gtk|icons|logdrake|net_applet|net_monitor|pixmaps|printer|roam|xf86misc|draknetprofile|\.png$/ ? print STDERR $_ : print' %{name}.list 2> %{name}-gtk.list
perl -ni -e '/http/ ? print STDERR $_ : print' %{name}.list 2> %{name}-http.list
perl -ni -e 'm!lib/libDrakX|bootloader-config|fileshare|lsnetdrake|drakupdate_fstab|rpcinfo|serial_probe! && !/newt/i ? print STDERR $_ : print' %{name}.list 2> %{name}-backend.list
perl -ni -e '/finish-install/ ? print STDERR $_ : print' %{name}.list 2> finish-install.list

#menu entry
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
mkdir -p $RPM_BUILD_ROOT%{_datadir}/autostart

cat > $RPM_BUILD_ROOT%{_datadir}/applications/pclinuxos-drakxtools-newt-system.desktop << EOF
[Desktop Entry]
Name=LocaleDrake (System)
Comment=System wide language configurator
Exec=/usr/bin/drakconf --start-with=Localization
Icon=localedrake.png
Type=Application
StartupNotify=true
Categories=GTK;X-MandrivaLinux-System-Configuration-Other;Settings;
EOF

cat > $RPM_BUILD_ROOT%{_datadir}/applications/pclinuxos-drakxtools-newt-user.desktop << EOF
[Desktop Entry]
Name=LocaleDrake (User)
Comment=Language configurator
Exec=/usr/bin/localedrake
Icon=localedrake.png
Type=Application
StartupNotify=true
Categories=GTK;X-MandrivaLinux-System-Configuration-Other;Settings;
EOF

cat > $RPM_BUILD_ROOT%{_datadir}/applications/pclinuxos-harddrake-ui.desktop << EOF
[Desktop Entry]
Name=HardDrake
Comment=Hardware Central Configuration/information tool
Exec=/usr/sbin/harddrake2
Icon=harddrake.png
Type=Application
StartupNotify=true
Categories=GTK;X-MandrivaLinux-System-Configuration-Hardware;Settings;HardwareSettings;
EOF

cat > $RPM_BUILD_ROOT%{_datadir}/applications/pclinuxos-net_applet.desktop << EOF
[Desktop Entry]
Name=NetApplet
Comment=Network monitoring applet
Exec=/usr/bin/net_applet --force
Icon=/usr/share/libDrakX/pixmaps/connected.png
Type=Application
Categories=GTK;X-MandrivaLinux-System-Monitoring;System;Monitor;
X-KDE-autostart-after=kdesktop
EOF
perl -pe 's/\s+--force//g' \
  $RPM_BUILD_ROOT%{_datadir}/applications/pclinuxos-net_applet.desktop > \
  $RPM_BUILD_ROOT%{_datadir}/autostart/pclinuxos-net_applet.desktop

cat > $RPM_BUILD_ROOT%_sysconfdir/X11/xinit.d/harddrake2 <<EOF
#!/bin/sh
exec /usr/share/harddrake/service_harddrake X11
EOF

cat > $RPM_BUILD_ROOT%_sysconfdir/sysconfig/harddrake2/kernel <<EOF
KERNEL=2.6
EOF

cat > $RPM_BUILD_ROOT%_sysconfdir/X11/xinit.d/net_applet <<EOF
#!/bin/sh
DESKTOP=\$1
case \$DESKTOP in
   GNOME|IceWM|Fluxbox|XFce4) exec /usr/bin/net_applet;;
esac
EOF

cat > $RPM_BUILD_ROOT%_sysconfdir/X11/wmsession.d/29drak3d <<EOF
NAME=drak3d
ICON=drak3d.png
EXEC=/usr/sbin/drak3d
DESC=3D Desktop effects configuration
SCRIPT:
exec /usr/sbin/drak3d
EOF

mv $RPM_BUILD_ROOT%_sbindir/service_harddrake_confirm $RPM_BUILD_ROOT%_datadir/harddrake/confirm

chmod +x $RPM_BUILD_ROOT{%_datadir/harddrake/{conf*,service_harddrake},%_sysconfdir/X11/xinit.d/{harddrake2,net_applet}}
# temporary fix until we reenable this feature
rm -f $RPM_BUILD_ROOT%_sysconfdir/X11/xinit.d/harddrake2

perl -I . -mharddrake::data -e 'print "DETECT_$_->{class}=yes\n" foreach @harddrake::data::tree' |sort > $RPM_BUILD_ROOT%_sysconfdir/sysconfig/harddrake2/service.conf

%find_lang libDrakX
%find_lang libDrakX-standalone
cat libDrakX.lang libDrakX-standalone.lang >> %name.list

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{update_desktop_database}
%make_session
[[ ! -e %_sbindir/kbdconfig ]] && %__ln_s -f keyboarddrake %_sbindir/kbdconfig
[[ ! -e %_sbindir/mouseconfig ]] && %__ln_s -f mousedrake %_sbindir/mouseconfig
[[ ! -e %_bindir/printtool ]] && %__ln_s -f ../sbin/printerdrake %_bindir/printtool
:

%postun
%{clean_desktop_database}
%make_session
for i in %_sbindir/kbdconfig %_sbindir/mouseconfig %_bindir/printtool;do
    [[ -L $i ]] && %__rm -f $i
done
:

%post http
%_post_service drakxtools_http

%preun http
%_preun_service drakxtools_http

%post newt
%{update_desktop_database}

%postun newt
%{clean_desktop_database}

%post -n harddrake-ui
%{update_desktop_database}

%postun -n harddrake-ui
%{clean_desktop_database}

%post -n harddrake
%_post_service harddrake

%preun -n harddrake
%_preun_service harddrake

%postun -n harddrake
file /etc/sysconfig/harddrake2/previous_hw | fgrep -q perl && %_datadir/harddrake/convert || :

%files backend -f %{name}-backend.list
%defattr(-,root,root)
%config(noreplace) /etc/security/fileshare.conf
%attr(4755,root,root) %_sbindir/fileshareset

%files newt -f %name.list
%defattr(-,root,root)
%{_datadir}/applications/pclinuxos-drakxtools-newt-system.desktop
%{_datadir}/applications/pclinuxos-drakxtools-newt-user.desktop
%doc diskdrake/diskdrake.html
%_iconsdir/localedrake.png
%_iconsdir/large/localedrake.png
%_iconsdir/mini/localedrake.png
%_mandir/*/*

%files -f %{name}-gtk.list
%defattr(-,root,root)
%_sysconfdir/X11/wmsession.d/29drak3d
%_sysconfdir/X11/xinit.d/net_applet
%{_datadir}/applications/pclinuxos-net_applet.desktop
%{_datadir}/autostart/pclinuxos-net_applet.desktop

%files -n harddrake
%defattr(-,root,root)
%_initrddir/harddrake
%dir /etc/sysconfig/harddrake2/
%config(noreplace) /etc/sysconfig/harddrake2/previous_hw
%config(noreplace) /etc/sysconfig/harddrake2/service.conf
%config(noreplace) %_sysconfdir/sysconfig/harddrake2/kernel
%dir %_datadir/harddrake/
%_datadir/harddrake/*
#%_sysconfdir/X11/xinit.d/harddrake2

%files -n harddrake-ui
%defattr(-,root,root)
%dir /etc/sysconfig/harddrake2/
%_sbindir/harddrake2
%_datadir/pixmaps/harddrake2
%{_datadir}/applications/pclinuxos-harddrake-ui.desktop
%_iconsdir/large/harddrake.png
%_iconsdir/mini/harddrake.png
%_iconsdir/harddrake.png

%files -n drakx-finish-install
%defattr(-,root,root)
%config(noreplace) %_sysconfdir/sysconfig/finish-install
%_sysconfdir/X11/xsetup.d/finish-install.xsetup
%_sbindir/finish-install

%files http -f %{name}-http.list
%defattr(-,root,root)
%dir %_sysconfdir/drakxtools_http
%config(noreplace) %_sysconfdir/pam.d/miniserv
%_sysconfdir/init.d/drakxtools_http
%config(noreplace) %_sysconfdir/drakxtools_http/conf
%config(noreplace) %_sysconfdir/drakxtools_http/authorised_progs
%config(noreplace) %_sysconfdir/logrotate.d/drakxtools-http

%changelog
* Mon May 19 2008 Gettinther <gettinther@gmail.com> 10.4-81flux-39pclos2008
- rebuild for perl 5.10.0

* Thu Apr 10 2008 Gettinther <gettinther@gmail.com> 10.4.81flux-32pclos_tinyme2007
- Rebuild against updated pclinuxos version
- Re-arranged release number to match pclinuxos's one

* Tue Dec 11 2007 Gettinther <gettinther@gmail.com> 10.4.81flux-24pclos_tinyme2007
- Made package pclinuxos independant

* Wed Oct 24 2007 Gettinther <gettinther@gmail.com> 10.4.81-23pclos_tinyme2007
- Rebuilt for Tinyme

* Tue Oct 02 2007 Gettinther <gettinther@gmail.com> 10.4.81-22pclos_tinyme2007
- Rebuilt for tinyme (remove requirement for pclos gftboot theme)

* Fri Sep 08 2007 Texstar <texstar@gmail.com> 10.4.81-21pclos2007
- fix drakx to get tell user to logout and back in again because
- it locks gnome when in 3d and selecting normal none 3d entry
- due to call to any.pm gnome-session-save --kill


* Sat Aug 04 2007 ocilent1 <ocilent1 at gmail dot com> 10.4.81-20pclos2007
- Xconfig: drop beryl and add compiz-fusion support (modifed patch 1)
- drak3d: drop compiz configuration via PCC (this confuses new users as
  it only configures compiz settings for root user!) (modifed patch 0)

* Thu May 17 2007 Texstar <texatr@gmail.com> 10.4.81-19pclos2007
- fix xdsl.pm to put correct information for ppoe connections

* Wed May 09 2007 Texstar <texstar@gmail.com> 10.4.81-18pclos2007
- add updated any.pm from Ivan
- disable any.pm patches
- update drakboot

* Thu Apr 26 2007 Texstar <texstar@gmail.com> 10.4.81-17pclos2007
- add in ivans change to finish install so it trys to mount both
- win_c and win_d when looking for ndiswrapper files

* Fri Mar 23 2007 Texstar <texstar@houston.rr.com> 10.4.81-16pclos2007
- let drakfont find windows fonts when user is using fuse
- Todo (need to fix window to close after sucessful font import)


* Tue Feb 27 2007 Texstar <texstar@houston.rr.com> 10.4.81-15pclos2007
- fix user icon on livecd install
- auto add user to video and audio group

* Fri Feb 23 2007 Texstar <texstar@houston.rr.com> 10.4.81-14pclos2007
- redo drakconnect icon 

* Sun Feb 04 2007 Texstar <texstar@houston.rr.com> 10.4.81-13pclos2007
- have finish-install do the network write setup routine instead
- of hwdetect to hopefully fix ipw2200 firmware setup

* Sat Jan 27 2007 Texstar <texstar@houston.rr.com> 10.4.81-12pclos2007
- add finish-install patch to try to mount /mnt/win_c so user can
- install ndiswrapper inf file from windows partition then have
- finish-install umount it when it closes

* Thu Jan 25 2007 Texstar <texstar@houston.rr.com> 10.4.81-11pclos2007
- merge in glx and drak3d patchs from latest drakxlibs

* Thu Jan 25 2007 Texstar <texstar@houston.rr.com> 10.4.81-10pclos2007
- sync up changes made on livecd any.pm2 and bootloader.pm2

* Tue Jan 09 2007 Texstar <texstar@houston.rr.com> 10.4.81-9pclos2007
- add mygtk2.pm patch to fix draklive-install window size
- add cpufreq patch
- fix typo in creation of autostart/pclinuxos-net_applet.desktop

* Mon Dec 18 2006 Texstar <texstar@houston.rr.com> 10.4.81-8pclos2007
- Rediff gfxboot patch to fix grub

* Sun Dec 10 2006 ocilent1 <ocilent1 at gmail dot com> 10.4.81-7pclos2007
- add gfxboot support (upstream 10.4.86)
- depreciate lilo splash image support
- fix naming of desktop files
- remove old menu code

* Tue Dec 05 2006 Texstar <texstar@houston.rr.com> 10.4.81-6pclos2007
- remove club join from harddrake2 as we dont have a club

* Mon Dec 04 2006 Texstar <texstar@houston.rr.com> 10.4.81-5pclos2007
- Apply various patches to covert to PCLinuxOS System
- Switch to apt-get install instead of urmpi for do packages
- remove urpmi dependency, rpmdrake, gurpmi and urpmi can now be removed.
- fix user icon for kdm login when using standard kde kdm login


* Sat Dec 02 2006 ocilent1 <ocilent1 at gmail dot com> 10.4.81-4pclos2007
- Sync with stable upsteam release
- kdesu needs a quoted string
- mirror API: enable edit-urpm-sources to ask for updates then distro
  sources
- drakauth:
  o add encrypted home and pam_mount support
  o hide password when calling "net join" or "net ads join"
- drakbackup:
  o fix star/tar selection issue
  o fix archiver detection/config file replace for real
  o do not backup the backups
- drakboot: support Xen with lilo using mbootpack
- drakfirewall: really disable services
- drakvpn:
  o add pkcs11 token support for openvpn
  o ask password/PIN if needed
- drakconnect/drakroam:
  o detect wireless interfaces with unknown driver, e.g. rt61
  o do not check for ipw3945 kernel module packages
  o do not wrongly tell that acx100-firmware can be found in Club or
    commercial editions
  o use iwpriv commands to configure WPA on rt2570 and rt61 chipsets
  o update madwifi URL
- finish-install:
  o add encrypted home and pam_mount support
  o use system() instead of run_program, because of buggy sensitive
    arguments handling
- printerdrake: due to changes in the format of HPLIP's device
  description XML files, scanners functionality were not recognized
  any more

* Wed Nov 22 2006 ocilent1 <ocilent1 at gmail dot com> 10.4.81-3pclos2007
- Update drak3d (upstream) [patches 0,1]:
  o adapt to updated compositing-wm-common configuration file
  o allow to select OpenGL compositing window manager
  o beryl support
  o use more generic "native" word instead of AIGLX, and reorganize drak3d accordingly
  o don't install task-3ddesktop but only required packages
  o assume the context is Xgl only if the server GLX vendor is "SGI"
- Add BuildRequires perl_checker

* Wed Nov 01 2006 Texstar <texstar@houston.rr.com> 10.4.81-2pclos2007
- Build for PCLinuxOS 2007
